require 'blazing/recipe'

class Blazing::Recipe::UpstartRestart < Blazing::Recipe

  def run(target_options = {})
    super target_options

    if options[:processes].nil? || options[:processes].empty?
      info "restarting appl"
      system "#{sudo} start #{application} || #{sudo} restart #{application}"
    else
      info "restarting app processes - [#{options[:processes]}"
      options[:processes].each do |p|
        system "#{sudo} start #{application}-#{p} || #{sudo} restart #{application}-#{p}"
      end
    end
  end

  private

  def application
    options[:app] || pwd
  end

  def pwd
    Dir.pwd.split('/').last
  end

  def sudo
    options[:sudo] || 'sudo'
  end

end