require 'rails/generators'
module Appboost
  class ForemanExportGenerator < Rails::Generators::Base
    desc "Foreman export"

    def self.default_procfile
      e = Rails.env == 'development' ? nil : Rails.env
      ['Procfile', e].compact.join('.')
    end

    def self.default_log
      Rails.root.join('log/foreman').to_s
    end

    def self.default_directory
      Rails.root.to_s
    end

    def self.default_app_name
      Dir.pwd.split('/').last
    end

    class_option :format,
      type: :string,
      default: 'upstart',
      desc: 'Format of foreman export'

    class_option :location,
      type: :string,
      default: '/etc/init'

    class_option :user,
      type: :string,
      default: 'app'

    class_option :app,
      type: :string,
      default: default_app_name

    class_option :procfile,
      type: :string,
      default: default_procfile

    class_option :concurrency,
      type: :string

    class_option :log,
      type: :string,
      default: default_log

    class_option :directory,
      type: :string,
      default: default_directory

    def export
      args = ["#{options[:format]} #{options[:location]}"]
      args << "-f #{options[:procfile]}"
      args << "-a #{options[:app]}"
      args << "-u #{options[:user]}"
      args << "-d #{options[:directory]}"
      args << "-l #{options[:log]}"
      args << "-c #{options[:concurrency]}" if options[:concurrency]

      system "bundle exec foreman export #{args.join(' ')}"
    end
      
    
  end
end