require 'rails/generators'
module Appboost
  class HostSiteGenerator < Rails::Generators::Base
    desc "Copy nginx conf file to nginx enabled sites folder"

    class_option :nginx_sites,
      type: :string,
      default: '/etc/nginx/sites-enabled',
      desc: 'Nginx sites enabled path',
      aliases: '-n'

    class_option :reload_nginx,
      type: :boolean,
      default: true,
      desc: 'Reload nginx after copying conf file',
      aliases: '-r'

    def copy_nginx_config
      copy_file "#{Dir.pwd}/config/nginx/#{app_name}.conf", "#{options[:nginx_sites]}/#{app_name}.conf"
    end

    def reload_nginx
      system "/etc/init.d/nginx reload" if options[:reload_nginx]
    end

    private
      
      def app_name
        Dir.pwd.split('/').last
      end
  end
end